/* Generated by camel build tools - do NOT edit this file! */
/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.camel.builder.endpoint.dsl;

import java.util.*;
import java.util.concurrent.*;
import java.util.function.*;
import java.util.stream.*;
import javax.annotation.processing.Generated;
import org.apache.camel.builder.EndpointConsumerBuilder;
import org.apache.camel.builder.EndpointProducerBuilder;
import org.apache.camel.builder.endpoint.AbstractEndpointBuilder;

/**
 * LangChain4j Chat component
 * 
 * Generated by camel build tools - do NOT edit this file!
 */
@Generated("org.apache.camel.maven.packaging.EndpointDslMojo")
public interface LangChain4jChatEndpointBuilderFactory {

    /**
     * Builder for endpoint for the langChain4j Chat component.
     */
    public interface LangChain4jChatEndpointBuilder
            extends
                EndpointProducerBuilder {
        default AdvancedLangChain4jChatEndpointBuilder advanced() {
            return (AdvancedLangChain4jChatEndpointBuilder) this;
        }

        /**
         * Operation in case of Endpoint of type CHAT. The value is one of the
         * values of
         * org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations.
         * 
         * The option is a:
         * <code>org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations</code> type.
         * 
         * Required: true
         * Default: CHAT_SINGLE_MESSAGE
         * Group: producer
         * 
         * @param chatOperation the value to set
         * @return the dsl builder
         */
        default LangChain4jChatEndpointBuilder chatOperation(org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations chatOperation) {
            doSetProperty("chatOperation", chatOperation);
            return this;
        }
        /**
         * Operation in case of Endpoint of type CHAT. The value is one of the
         * values of
         * org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations.
         * 
         * The option will be converted to a
         * <code>org.apache.camel.component.langchain4j.chat.LangChain4jChatOperations</code> type.
         * 
         * Required: true
         * Default: CHAT_SINGLE_MESSAGE
         * Group: producer
         * 
         * @param chatOperation the value to set
         * @return the dsl builder
         */
        default LangChain4jChatEndpointBuilder chatOperation(String chatOperation) {
            doSetProperty("chatOperation", chatOperation);
            return this;
        }
    }

    /**
     * Advanced builder for endpoint for the langChain4j Chat component.
     */
    public interface AdvancedLangChain4jChatEndpointBuilder
            extends
                EndpointProducerBuilder {
        default LangChain4jChatEndpointBuilder basic() {
            return (LangChain4jChatEndpointBuilder) this;
        }

        /**
         * Whether the producer should be started lazy (on the first message).
         * By starting lazy you can use this to allow CamelContext and routes to
         * startup in situations where a producer may otherwise fail during
         * starting and cause the route to fail being started. By deferring this
         * startup to be lazy then the startup failure can be handled during
         * routing messages via Camel's routing error handlers. Beware that when
         * the first message is processed then creating and starting the
         * producer may take a little time and prolong the total processing time
         * of the processing.
         * 
         * The option is a: <code>boolean</code> type.
         * 
         * Default: false
         * Group: producer (advanced)
         * 
         * @param lazyStartProducer the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointBuilder lazyStartProducer(boolean lazyStartProducer) {
            doSetProperty("lazyStartProducer", lazyStartProducer);
            return this;
        }
        /**
         * Whether the producer should be started lazy (on the first message).
         * By starting lazy you can use this to allow CamelContext and routes to
         * startup in situations where a producer may otherwise fail during
         * starting and cause the route to fail being started. By deferring this
         * startup to be lazy then the startup failure can be handled during
         * routing messages via Camel's routing error handlers. Beware that when
         * the first message is processed then creating and starting the
         * producer may take a little time and prolong the total processing time
         * of the processing.
         * 
         * The option will be converted to a <code>boolean</code> type.
         * 
         * Default: false
         * Group: producer (advanced)
         * 
         * @param lazyStartProducer the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointBuilder lazyStartProducer(String lazyStartProducer) {
            doSetProperty("lazyStartProducer", lazyStartProducer);
            return this;
        }
        /**
         * Chat Language Model of type
         * dev.langchain4j.model.chat.ChatLanguageModel.
         * 
         * The option is a:
         * <code>dev.langchain4j.model.chat.ChatLanguageModel</code> type.
         * 
         * Group: advanced
         * 
         * @param chatModel the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointBuilder chatModel(dev.langchain4j.model.chat.ChatLanguageModel chatModel) {
            doSetProperty("chatModel", chatModel);
            return this;
        }
        /**
         * Chat Language Model of type
         * dev.langchain4j.model.chat.ChatLanguageModel.
         * 
         * The option will be converted to a
         * <code>dev.langchain4j.model.chat.ChatLanguageModel</code> type.
         * 
         * Group: advanced
         * 
         * @param chatModel the value to set
         * @return the dsl builder
         */
        default AdvancedLangChain4jChatEndpointBuilder chatModel(String chatModel) {
            doSetProperty("chatModel", chatModel);
            return this;
        }
    }

    public interface LangChain4jChatBuilders {
        /**
         * langChain4j Chat (camel-langchain4j-chat)
         * LangChain4j Chat component
         * 
         * Category: ai
         * Since: 4.5
         * Maven coordinates: org.apache.camel:camel-langchain4j-chat
         * 
         * @return the dsl builder for the headers' name.
         */
        default LangChain4jChatHeaderNameBuilder langchain4jChat() {
            return LangChain4jChatHeaderNameBuilder.INSTANCE;
        }
        /**
         * langChain4j Chat (camel-langchain4j-chat)
         * LangChain4j Chat component
         * 
         * Category: ai
         * Since: 4.5
         * Maven coordinates: org.apache.camel:camel-langchain4j-chat
         * 
         * Syntax: <code>langchain4j-chat:chatId</code>
         * 
         * Path parameter: chatId (required)
         * The id
         * 
         * @param path chatId
         * @return the dsl builder
         */
        default LangChain4jChatEndpointBuilder langchain4jChat(String path) {
            return LangChain4jChatEndpointBuilderFactory.endpointBuilder("langchain4j-chat", path);
        }
        /**
         * langChain4j Chat (camel-langchain4j-chat)
         * LangChain4j Chat component
         * 
         * Category: ai
         * Since: 4.5
         * Maven coordinates: org.apache.camel:camel-langchain4j-chat
         * 
         * Syntax: <code>langchain4j-chat:chatId</code>
         * 
         * Path parameter: chatId (required)
         * The id
         * 
         * @param componentName to use a custom component name for the endpoint
         * instead of the default name
         * @param path chatId
         * @return the dsl builder
         */
        default LangChain4jChatEndpointBuilder langchain4jChat(String componentName, String path) {
            return LangChain4jChatEndpointBuilderFactory.endpointBuilder(componentName, path);
        }

    }
    /**
     * The builder of headers' name for the langChain4j Chat component.
     */
    public static class LangChain4jChatHeaderNameBuilder {
        /**
         * The internal instance of the builder used to access to all the
         * methods representing the name of headers.
         */
        private static final LangChain4jChatHeaderNameBuilder INSTANCE = new LangChain4jChatHeaderNameBuilder();

        /**
         * The prompt Template.
         * 
         * The option is a: {@code String} type.
         * 
         * Group: producer
         * 
         * @return the name of the header {@code LangChain4jChatPromptTemplate}.
         */
        public String langChain4jChatPromptTemplate() {
            return "CamelLangChain4jChatPromptTemplate";
        }
    }
    static LangChain4jChatEndpointBuilder endpointBuilder(String componentName, String path) {
        class LangChain4jChatEndpointBuilderImpl extends AbstractEndpointBuilder implements LangChain4jChatEndpointBuilder, AdvancedLangChain4jChatEndpointBuilder {
            public LangChain4jChatEndpointBuilderImpl(String path) {
                super(componentName, path);
            }
        }
        return new LangChain4jChatEndpointBuilderImpl(path);
    }
}